
#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>

#include "rubikcube.h"
#include "main.h"


 GLenum      polygonMode=GL_LINE;
 //float       rotX=-45.0, rotY=45.0;
 float       rotX=0, rotY=0;

RubikCube r(4);


void Init()
{
		//Z-Buffer
		glEnable(GL_DEPTH_TEST); 
		//Front and back should be rendered
 		glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);


		static float light0_diffuse[] = {0.4, 0.4, 0.4, 1.0};
		static float light0_pos[] = {3.0, 3.0, 3.0, 1.0};

		static float lmodel_ambient[] = {0.8, 0.8, 0.8, 1.0};


		glLightfv(GL_LIGHT0, GL_DIFFUSE, light0_diffuse);
		glLightfv(GL_LIGHT0, GL_POSITION, light0_pos);

		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
		glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);

		glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT0);
}


void Display()
{
		//Clear depth- and frame-buffer
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
		glLoadIdentity();

		glTranslatef(0, 0, -2.5);
		glRotatef( rotX, 1, 0, 0);
		glRotatef( rotY, 0, 0, 1);


		r.glDisplay();


		glutSwapBuffers();
}


static void Reshape(int width, int height)
{
    /* Darstellung auf gesamten Clientbereich des Fensters zulassen */
     glViewport(0, 0, (GLint)width, (GLint)height);
   
     /* Projektionsmatix initialisieren auf 60 Grad horizontales */
     /* Sichtfeld, Verhaeltnis Breite:Hoehe = 1:1, Clipping fuer z<1 */
     /* und z>200 */
     glMatrixMode(GL_PROJECTION);
     glLoadIdentity();
     /* angle, aspect, near Clip, far Clip */
     gluPerspective(60.0, 1.0, 1.0, 200.0);
   
     /* Modelview Matrix wieder zur aktuellen Matrix machen */
     glMatrixMode(GL_MODELVIEW);

}


static void Key(unsigned char key, int x, int y)
{
	if (key==27) 
    	exit(1);

	if (key==' ')
	{
			r.hightlightNext();
			glutPostRedisplay ();
	}

	if( key==13 )
	{
			r.glRotate(250);
	}
}
   
   static void SpecialKey(int key, int x, int y)
   {
     switch (key) {
     case GLUT_KEY_UP:
       rotX -= 5;
       break;
     case GLUT_KEY_DOWN:
       rotX += 5;
       break;
     case GLUT_KEY_LEFT:
       rotY -= 5;
       break;
     case GLUT_KEY_RIGHT:
       rotY += 5;
       break;
     default:
       return;
     }
     glutPostRedisplay();
   }


int main(int argc, char** argv)
{
		printf("Launching cube...\n");

		glutInit(&argc, argv);

		glutInitWindowPosition(0, 0);
		glutInitWindowSize( 300, 300);
		glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE);

		if (glutCreateWindow("Sample1") == GL_FALSE)
				exit(1);
	    
		Init();
    /* Callback Funktionen vereinbaren */
     glutReshapeFunc(Reshape);
     glutKeyboardFunc(Key);
     glutSpecialFunc(SpecialKey);
		glutDisplayFunc(Display);

		glutMainLoop();

		return 0;
}


